<?php 

/*
 * Helper Function for getting DB Size, file size, and bandwidth useage
 */

/*
 * Returns Database use
 */
function _resource_db_useage( $object = array() ){
	$db_name = str_replace('.', '', $object['url'] );
	$db_name = substr($db_name, 0, 16);	
	$result = db_fetch_object(db_query("SELECT CONCAT(sum(ROUND(( ( (DATA_LENGTH + INDEX_LENGTH - DATA_FREE)))) ) ) AS Size FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA LIKE '%s'", $db_name));
	
	return $result->Size;	
}

/*
 * Returns Filespace use
 */
function _resource_file_useage( $object = array() ){
	 $site_node = node_load(array('title' => $object['url']));
	 
	 $platform_node = node_load(array('nid' => $site_node->platform));
	 $dirSize = _getDirSize($platform_node->publish_path.'/sites/'.$site_node->title);
	 
	 return $dirSize;
	 
}

function _getDirSize( $path ){
	$totalsize = 0; 
  	$totalcount = 0; 
  	$dircount = 0; 
	  if ($handle = opendir ($path)) 
	  { 
	    while (false !== ($file = readdir($handle))) 
	    { 
	      $nextpath = $path . '/' . $file; 
	      if ($file != '.' && $file != '..' && !is_link ($nextpath)) 
	      { 
	        if (is_dir ($nextpath)) 
	        { 
	          $dircount++; 
	          $result = _getDirSize($nextpath); 
	          $totalsize += $result['size']; 
	          $totalcount += $result['count']; 
	          $dircount += $result['dircount']; 
	        } 
	        elseif (is_file ($nextpath)) 
	        { 
	          $totalsize += filesize ($nextpath); 
	          $totalcount++; 
	        } 
	      } 
	    } 
		closedir ($handle);  
	  } else {
	  	 // drupal_set_message('ERROR OPENING DIR'); 
	  } 
  	$total['size'] = $totalsize; 
  	$total['count'] = $totalcount; 
  	$total['dircount'] = $dircount; 
  	return $total;
}

function _sizeFormat($size) 
{ 
    if($size<1024) 
    { 
        return $size." bytes"; 
    } 
    else if($size<(1024*1024)) 
    { 
        $size=round($size/1024,1); 
        return $size." KB"; 
    } 
    else if($size<(1024*1024*1024)) 
    { 
        $size=round($size/(1024*1024),1); 
        return $size." MB"; 
    } 
    else 
    { 
        $size=round( ($size/(1024*1024*1024)), 2); 
        return $size." GB"; 
    } 

}

/*
 * Returns the Resource use 
 * 
 */
function _resource_bandwidth_useage( $object = array() ){
	// we need to call back to the mod_cband's cband-status page which was configured in 
	// Aegir's vhost file, we use Aegir's cband-status so that we do not increment the users bandwidth
	// when we check the current useage.
	$url = $_SERVER['HTTP_REFERER'];
	$domain = parse_url($url, PHP_URL_HOST);
	$url = $domain.'/'.drupal_get_path('module', 'hostmaster_resources').'/cband-status.html?xml'; 
	
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_HEADER, false);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
	$xml = simplexml_load_string(curl_exec($ch));
	curl_close($ch);
	$display = '';
	if(isset($xml->Virtualhosts->virtualhost)){
	foreach($xml->Virtualhosts->virtualhost as $virtualhost){
		if(($virtualhost->name == $object['url'])){
			$display = $virtualhost->usages->total;
		}
	}
	} else {
		$display.='Their is an error in your settings.';
	}
	return $display;	
}

?>