<?php 

/*
 * Implementation of hook_rules_event_info
 */
function hostmaster_rules_rules_event_info( ){
    $rule_events = array();
    $rule_events['task_insert'] = array( 
        'label' => t('New Task Created'),
		'module' => 'Hostmaster',
		'arguments' => array(hostmaster_rules_event_task_arguments( t('New Task') ) )
    );
    $rule_events['task_update'] = array(
        'label' => t('Task Has Been Updated'),
		'module' => 'Hostmaster',
		'arguments' => array( hostmaster_rules_event_task_arguments(t('Updated Task') ) )
    );
    $rule_events['task_delete'] = array(
		'label' => t('Task Has Been Deleted'),
		'module' => 'Hostmaster',
		'arguments' => array( hostmaster_rules_event_task_arguments(t('Deleted Task') ) )
	);
    $rule_events['site_insert'] = array(
		'label' => t('New Site Created'),
		'module' => 'Hostmaster',
		'arguments' => array( hostmaster_rules_event_site_arguments( t('New Site') ) )
	);
	$rule_events['site_update'] = array(
		'label' => t('Site Updated'),
		'module' => 'Hostmaster',
		'arguments' => array( hostmaster_rules_event_site_arguments( t('Updated Site')))
	);
    $rule_events['site_delete'] = array(
		'label' => t('Site Deleted'),
		'module' => 'Hostmaster',
		'arguments' => array( hostmaster_rules_event_site_arguments( t('Deleted Site')))
	);
	$rule_events['platform_insert'] = array(
		'label' => t('New Platform'),
		'module' => 'Hostmaster',
		'arguments' => array( hostmaster_rules_event_platform_arguments( t('New Platform')))
	);
	$rule_events['platform_update'] = array(
		'label' => t('Platform Updated'),
		'module' => 'Hostmaster',
		'arguments' => array( hostmaster_rules_event_platform_arguments( t('Updated Platform')))
	);
	$rule_events['platform_delete'] = array(
		'label' => t('Platform Deleted'),
		'module' => 'Hostmaster',
		'arguments' => array( hostmaster_rules_event_platform_arguments( t('Deleted Platform')))
	);
	$rule_events['client_insert'] = array(
		'label' => t('New Client'),
		'module' => 'Hostmaster',
		'arguments' => array( hostmaster_rules_event_client_arguments( t('New Client')))
	);
	$rule_events['client_update'] = array(
		'label' => t('Client Updated'),
		'module' => 'Hostmaster',
		'arguments' => array( hostmaster_rules_event_client_arguments( t('Updated Client')))
	);
	$rule_events['client_delete'] = array(
		'label' => t('Client Deleted'),
		'module' => 'Hostmaster',
		'arguments' => array( hostmaster_rules_event_client_arguments( t('Deleted Client')))
	);
	$rule_events['server_insert'] = array(
		'label' => t('New Server'),
		'module' => 'Hostmaster',
		'arguments' => array( hostmaster_rules_event_client_arguments( t('New Server')))
	);
	$rule_events['server_update'] = array(
		'label' => t('Server Updated'),
		'module' => 'Hostmaster',
		'arguments' => array( hostmaster_rules_event_client_arguments( t('Updated Server')))
	);
	$rule_events['server_delete'] = array(
		'label' => t('Server Deleted'),
		'module' => 'Hostmaster',
		'arguments' => array( hostmaster_rules_event_client_arguments( t('Deleted Server')))
	);
}

function hostmaster_rules_event_task_arguments($task_label ){
	$args = array(
    'task' => array(
      'type' => 'task',
      'label' => $task_label,
    ));
   return $args;
}

function hostmaster_rules_event_site_arguments($site_label){
	$args = array(
		'site' => array(
			'type' => 'site',
			'label' => $site_label,
		)
	);
	return $args;
}

function hostmaster_rules_event_platform_arguments($platform_label){
 $args = array(
 	'platform' => array(
 		'type' => 'platform',
 		'label' => $platform_label
 	)
 	);
 	return $args;
}

function hostmaster_rules_event_client_arguments($client_label){
 $args = array(
 	'client' => array(
 		'type' => 'client',
 		'label' => $client_label
 	)
 	);
 	return $args;	
}

function hostmaster_rules_event_server_arguments($server_label){
 $args = array(
 	'server' => array(
 		'type' => 'server',
 		'label' => $server_label
 	)
 	);
 	return $args;	
}

/*
 * hook_rules_condition_info - defines conditions
 */
function hostmaster_rules_rules_condition_info(){
	$conditions = array(
	// Task Related Conditions Status, and Types
	'hostmaster_rules_condition_task_status' => array( 
			'label' => t('Task Status'),
			'module' => 'Hostmaster',
			'eval input' => array('task_status'),
			'arguments' => array('task' => array('type' => 'task', 'label' => t('Hostmaster Task')) ),
	),
	'hostmaster_rules_condition_task_type' => array(
		'label' => t('Task Type'),
		'module' => 'Hostmaster',
		'eval input' => array('task_type'),
		'arguments' => array('task' => array('type' => 'task', 'label' => t('Hostmaster Task') ) ),
	),
	// Client Related Conditions
	'client_has_live_sites' => array(
		'label' => t('Client Has Enabled Site(s)'),
		'module' => 'Hostmaster',
	),
	'client_has_disabled_sites' => array(
		'label' => t('Client Has Disabled Site(s)'),
		'module' => 'Hostmaster'
	),
	// Site related Conditions
	'site_enabled' => array(
		'label' => t('Site Enabled'),
		'module' => 'Hostmaster',
	),
	// Platform Related Conditions
	'site_has_profile' => array(
		'label' => t('Site has install profile'),
		'module' => 'Hostmaster',
		'eval input' => array('site_profile')
	),
	'site_has_platform' => array(
		'label' => t('Site Has platform'),
		'module' => 'Hostmaster',
		'eval input' => array('site_platform')
	) 
	
	);
	return $conditions;
}

/*
 * Checks the status of the task
 */
function hostmaster_rules_condition_task_status(&$task, $settings){
	if(in_array($task->task_status, $settings['task_status']) ){
		return true;
	} else {
		return false;
	}
}

/*
 * Checks the Type of task
 */
function hostmaster_rules_condition_task_type(&$task, $settings ){
	if(in_array($task->task_type, $settings['task_type'])){
		return true;
	} else {
		return false;
	}
}


?>