<?php 

/*
 * Validate that a top level domain is pointing to the server
 * Arguments:
 * $sessid - session id passed to call from services api
 * $url - domain we are wishing to validate
 * $platform - platform(node id) we are wanting to validate against
 */
function dnsVerify( $sessid, $url, $platform ){
  $dnsCheck = dns_get_record($url);
  $plat = node_load(array('nid' => $platform));
  $server = node_load(array('nid' => $plat->web_server ));
  foreach($dnsCheck as $dnsEntry){
    if($dnsEntry['type'] == 'A'){
       if(in_array($dnsEntry['ip'], $server->ip_addresses)){
         return true;
       } 
    }
  }
  return false;
}


?>